#include <QtGui/QApplication>
#include <QList>
#include <QString>
#include <QDir>
#include <iostream>
#include "MainWindow.h"
#include "DepthControl.h"
#include "LayerDepth.h"
#include "Image.h"
#include "LinearSystem.h"

void DepthMap(int width=10);

int main(int argc, char *argv[])
{
	//double A[9]={60, -20,1,-20,100,30,1,30,50};
	//double b[3]={1,2,3};
	//double x[3];
	//LinearSystem::ConjugateGradient(3,A,b,x);
	////LinearSystem::Ax(3,A,b,x);
	//LinearSystem::printMatrix(3,A);
	//LinearSystem::printVector(3,x);
	//return 1;

	QString path=QDir::currentPath();
	if (path.right(1)!="/")
		path+="/";
	path += "imageformats";

    QApplication a(argc, argv);
	QApplication::addLibraryPath(path);

	//DepthMap();

    MainWindow w;
    w.show();
    a.connect(&a, SIGNAL(lastWindowClosed()), &a, SLOT(quit()));
    return a.exec();
}

void DepthMap(int width)
{
	BiImage image(width,256,3);
	unsigned char* pData=image.data();
	QColor color;
	int RGB[3];

	for(int i=0;i<256;i++)
	{
		color.setHsv(i,255,255);
		RGB[0]=color.red();
		RGB[1]=color.green();
		RGB[2]=color.blue();
		for(int j=0;j<width;j++)
			for(int k=0;k<3;k++)
				pData[(i*width+j)*3+k]=RGB[k];
	}
	image.imwrite("DepthMap.bmp");
}

//int main(int argc, char *argv[])
//{
//	int nFrames=100;
//	QList<LayerDepth> DepthList;
//
//	LayerDepth layerDepth;
//	QList<int> index;
//	QList<int> depth;
//	index.append(0);
//	depth.append(30);
//	index.append(3);
//	depth.append(20);
//	index.append(27);
//	depth.append(100);
//	index.append(65);
//	depth.append(60);
//	layerDepth.Initialize(nFrames,0,nFrames-1,index,depth);
//	layerDepth.InterpolateLinear();
//	layerDepth.InterpolateCG(nFrames*3);
//	DepthList.append(layerDepth);
//
//	index.clear();
//	depth.clear();
//	index.append(40);
//	depth.append(120);
//	index.append(78);
//	depth.append(60);
//	layerDepth.Initialize(nFrames,10,nFrames-10,index,depth);
//	layerDepth.InterpolateLinear();
//	layerDepth.InterpolateCG(nFrames*3);
//	DepthList.append(layerDepth);
//
//    QApplication a(argc, argv);
//    DepthControl depthControl(NULL);
//	depthControl.loadDepthList(DepthList,0,40);
//    depthControl.show();
//    a.connect(&a, SIGNAL(lastWindowClosed()), &a, SLOT(quit()));
//    return a.exec();
//}

//int main(int argc, char *argv[])
//{
//    QApplication a(argc, argv);
//    DepthControl depthControl(NULL);
//    depthControl.show();
//    a.connect(&a, SIGNAL(lastWindowClosed()), &a, SLOT(quit()));
//    return a.exec();
//}

